#include "CounterRuleDlg.h"

CounterRuleDlg::CounterRuleDlg(wxWindow *parent, RuleMode nMode, wxWindowID id, const wxPoint &pos, const wxSize &size):
    CounterRuleDlgBase(parent),
    m_nMode(nMode),
    m_pMapCounterRule(0),
    m_pFileExt(0)
{
}

CounterRuleDlg::~CounterRuleDlg()
{
}

void CounterRuleDlg::OnInit(wxInitDialogEvent &event)
{
    MapStrToCounterRule::iterator it;
    CounterRule *pRule = 0;
    for ( it = m_pMapCounterRule->begin(); it != m_pMapCounterRule->end(); ++it )
    {
        pRule = it->second;
        m_cmbMethod->AppendString(pRule->m_strType);
    }

    if (m_nMode == RuleModeNew)
    {
        m_cmbMethod->Select(0);
    }

    if (m_nMode == RuleModeEdit)
    {
        m_txtExtName->SetValue(m_pFileExt->m_strName);
        m_txtExtName->Enable(false);
        m_txtExtDesc->SetValue(m_pFileExt->m_strDesc);

        m_cmbMethod->SetValue(m_pFileExt->m_strCounterType);

    }

    updateRuleCtrls();
}

void CounterRuleDlg::OnCmbMethodSelect(wxCommandEvent &event)
{
    updateRuleCtrls();
}

void CounterRuleDlg::updateRuleCtrls()
{
    MapStrToCounterRule::iterator it;
    it = m_pMapCounterRule->find(m_cmbMethod->GetValue());

    CounterRule *pRule = 0;
    if (it != m_pMapCounterRule->end())
    {
        // Find instance in the pCount map
        pRule = it->second;
    }

    m_txtRuleDesc->SetValue(pRule->m_strDesc);
    m_txtSlgLnComm->SetValue(pRule->m_strSlgLnComm);
    m_txtMltLnCommBegin->SetValue(pRule->m_strMltLnCommBegin);
    m_txtMltLnCommEnd->SetValue(pRule->m_strMltLnCommEnd);

}

void CounterRuleDlg::OnBtnOKClick(wxCommandEvent &event)
{
    // Check input info
    wxString strExtDesc = m_txtExtDesc->GetValue();
    if(strExtDesc.IsEmpty())
    {
        wxMessageBox(_("Please input file extension description!"));
        return;
    }

    if(m_nMode == RuleModeNew)
    {
        wxString strExtName = m_txtExtName->GetValue();
        if(strExtName.IsEmpty())
        {
            wxMessageBox(_("Please input file extension!"));
            return;
        }

        m_pFileExt->m_strName = strExtName;
    }

    m_pFileExt->m_strDesc = strExtDesc;
    m_pFileExt->m_strCounterType = m_cmbMethod->GetValue();

    wxString strRuleDesc = m_txtRuleDesc->GetValue();
    if(strRuleDesc.IsEmpty())
    {
        wxMessageBox(_("Please input style description!"));
        return;
    }

    wxString strRuleType = m_cmbMethod->GetValue();
    MapStrToCounterRule::iterator it;
    it = m_pMapCounterRule->find(strRuleType);
    CounterRule *pRule = it->second;
    pRule->m_strDesc = strRuleDesc;

    EndModal(wxID_OK);
}

void CounterRuleDlg::OnBtnCancelClick(wxCommandEvent &event)
{
    EndModal(wxID_CANCEL);
}
