#ifndef CounterRuleDlg_H
#define CounterRuleDlg_H

#include "CountingManager.h"
#include "CounterRule.h"

#include "CounterRuleDlgBase.h"

class CounterRuleDlg: public CounterRuleDlgBase
{
public:

    enum RuleMode
    {
        RuleModeNew,
        RuleModeEdit,
    };

    CounterRuleDlg(wxWindow *parent, RuleMode nMode = RuleModeNew, wxWindowID id = wxID_ANY, const wxPoint &pos = wxDefaultPosition, const wxSize &size = wxDefaultSize);
    virtual ~CounterRuleDlg();

 
    void SetRuleData(MapStrToCounterRule *pMapCounterRule, FileExtension *pFileExt)
    {
        m_pMapCounterRule = pMapCounterRule;
        m_pFileExt = pFileExt;
    }

private:

    void OnInit(wxInitDialogEvent &event);
    void OnBtnOKClick(wxCommandEvent &event);
    void OnBtnCancelClick(wxCommandEvent &event);
    void OnCmbMethodSelect(wxCommandEvent &event);

    RuleMode m_nMode;
    MapStrToCounterRule *m_pMapCounterRule;
    FileExtension *m_pFileExt;

    void updateRuleCtrls();
};

#endif
