/**
 * @file CppCounter.cpp
 * @brief implementation of the CppCounter class.
 * @author Boom( boomworks@hotmail.com )
 * @author Copyright(C) 2004-2005 boomworks.org , All right reserved.
 * @date 2005-12-10
 * $Revision: $
 */

#include <wx/textfile.h>
#include "CppCounter.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#define new DEBUG_NEW
#endif

//////////////////////////////////////////////////////////////////////
// CppCounter
//////////////////////////////////////////////////////////////////////

wxString CppCounter::ms_strType = _T("C");

CppCounter *CppCounter::ms_instance = 0;

CppCounter::CppCounter()
{}

CppCounter::~CppCounter()
{}

CppCounter *CppCounter::GetInstance()
{
    if ( ms_instance == 0)
    {
        ms_instance = new CppCounter;
    }
    return ms_instance;
}

void CppCounter::countingSourceFile(wxTextFile &file, int &nLines, int &nCodeLines, int &nCommentLines, int &nBlankLines )
{
    // get file size
    // nSize = file.Len();

    //////////////////////////////////////////////////////////////////////////

    BOOL bCommentSet = FALSE;
    BOOL bQuatoSet = FALSE;

    wxString bufRead;


    for ( bufRead = file.GetFirstLine(); !file.Eof(); bufRead = file.GetNextLine() )
    {
        BOOL bStatedComment = FALSE;
        BOOL bStatedCode = FALSE;

        nLines++;

        bufRead.Trim(false);

        if ( bufRead.Len() == 0 )
        {
            nBlankLines++;
            continue;
        }

        if ( bCommentSet && bufRead.Find( _T("*/") ) == -1 )
        {
            nCommentLines++;
            continue;
        }

        if ( bufRead.Find( _T("//") ) == -1 && bufRead.Find( _T("/*") ) == -1 && bufRead.Find( _T("*/") ) == -1 )
        {
            if ( bCommentSet )
            {
                nCommentLines++;
                continue;
            }
            else
            {
                if ( bufRead.Find( _T('"') ) == -1 )
                {
                    nCodeLines++;
                    continue;
                }
            }
        }

        if ( bufRead.Find( _T("//") ) == 0 && !bCommentSet && !bQuatoSet )
        {
            nCommentLines++;
            continue;
        }

        BOOL bDoubleSlashFound = FALSE;
        BOOL bSplashStarFound = FALSE;

        for (unsigned int i = 0; i < bufRead.Len() - 1; i++)
        {
            // TCHAR cTemp = bufRead[i];
            if ( bufRead[i] == _T('/') && bufRead[i + 1] == _T('/') && !bCommentSet && !bQuatoSet )
            {
                if ( !bStatedComment
                        && ( m_nLineCountingType == NStatisticAll || m_nLineCountingType == NStatisticCommentOnly ))
                {
                    bStatedComment = TRUE;
                    nCommentLines++;
                }
                bDoubleSlashFound = TRUE;
                break;
            }
            else if ( bufRead[i] == _T('/') && bufRead[i + 1] == _T('*') && !bCommentSet && !bQuatoSet )
            {
                if ( !bStatedComment
                        && ( m_nLineCountingType == NStatisticAll || m_nLineCountingType == NStatisticCommentOnly ))
                {
                    bStatedComment = TRUE;
                    nCommentLines++;
                }
                bCommentSet = TRUE;
                bSplashStarFound = TRUE;
                i++;
            }

            else if ( bufRead[i] != _T(' ') && bufRead[i] != _T('\t') && !bCommentSet )
            {
                if ( !bStatedCode )
                {
                    bStatedCode = TRUE;
                    nCodeLines++;
                }
                if ( bufRead[i] == _T('\\') )
                {
                    i++;
                    continue;
                }
                if ( bufRead[i] == '\'' )
                {
                    if ( bufRead[i + 1] == '\\' )
                        i += 2;
                    else
                        i += 1;
                    continue;
                }
                if ( bufRead[i] == '"' )
                {
                    bQuatoSet = !bQuatoSet;
                }
            }
            else if ( bufRead[i] == '*' && bufRead[i + 1] == '/' && bCommentSet && !bQuatoSet )
            {
                if ( !bStatedComment
                        && ( m_nLineCountingType == NStatisticAll || m_nLineCountingType == NStatisticCommentOnly))
                {
                    bStatedComment = TRUE;
                    nCommentLines++;
                }
                bCommentSet = FALSE;
                bSplashStarFound = TRUE;
                i++;
            }
        }

        if ( bDoubleSlashFound )
        {
            if ( m_nLineCountingType == NStatisticCommentOnly && bStatedCode )
            {
                nCodeLines--;
            }

            if ( m_nLineCountingType == NStatisticCodeOnly && !bStatedCode )
            {
                nCommentLines++;
            }
            continue;
        }

        if ( bufRead[bufRead.Len() - 1] == '"' && !bCommentSet )
        {
            bQuatoSet = !bQuatoSet;
            if ( !bQuatoSet )
            {
                if ( !bStatedCode )
                {
                    bStatedCode = TRUE;
                    nCodeLines++;
                }
            }
            else
            {
            }
            continue;
        }

        if ( bufRead[bufRead.Len() - 1] != ' ' && bufRead[bufRead.Len() - 1] != '\t' && !bCommentSet
                && bufRead[bufRead.Len() - 2] != '*' && bufRead[bufRead.Len() - 1] != '/' )
        {
            if ( !bStatedCode )
            {
                bStatedCode = TRUE;
                nCodeLines++;
            }
        }

        if ( bSplashStarFound )
        {
            if ( m_nLineCountingType == NStatisticCommentOnly && bStatedCode )
            {
                nCodeLines--;
            }

            if ( m_nLineCountingType == NStatisticCodeOnly && !bStatedCode && !bStatedComment )
            {
                bStatedComment = TRUE;
                nCommentLines++;
            }
        }

        if ( !bStatedComment && bCommentSet )
        {
            if ( m_nLineCountingType == NStatisticCodeOnly && !bStatedCode )
            {
                bStatedComment = TRUE;
                nCommentLines++;
            }
        }
    }
}
