/**
 * @file PasCounter.cpp
 * @brief implementation of the PascalCounter class.
 * @author Boom( boomworks@hotmail.com )
 * @author Copyright(C) 2004-2005 boomworks.org , All right reserved.
 * $Author: $
 * $Date: $
 * $Revision: $
 * $ID: $
 */

#include <wx/textfile.h>

#include "PasCounter.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#define new DEBUG_NEW
#endif

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

wxString PascalCounter::ms_strType = _T("Pascal");

PascalCounter::PascalCounter()
{}

PascalCounter::~PascalCounter()
{}

void PascalCounter::countingSourceFile( wxTextFile &file, int &nLines, int &nCodeLines, int &nCommentLines, int &nBlankLines )
{
    BOOL bHasSettedCommentFlag	= FALSE;
    BOOL bHasSettedQuatoFlag	= FALSE;

    wxString bufCurLine;
    for ( bufCurLine = file.GetFirstLine(); !file.Eof(); bufCurLine = file.GetNextLine() )
    {
        nLines++;

        bufCurLine.Trim(false);

        if ( bufCurLine.Len() == 0 )
        {
            nBlankLines++;
            continue;
        }

        //////////////////////////////////////////////////////////////////////////

        bufCurLine.Trim();
        int nLen = bufCurLine.Len();
        if ( !bHasSettedCommentFlag
                && bufCurLine[ 0 ]			==  _T( '{' )
                && bufCurLine[ nLen - 1 ]	==  _T( '}' ))
        {
            nCommentLines++;
            continue;
        }
        else if ( !bHasSettedCommentFlag
                  && bufCurLine.Find( _T( "{" )) != -1
                  && bufCurLine.Find( _T( "}" )) != -1 )
        {
            nCommentLines++;
            nCodeLines++;
            continue;
        }

        if ( !bHasSettedCommentFlag )
        {
            if ( bufCurLine[0]	== _T( '/' )
                    && bufCurLine[1]		== _T( '/' ) )
            {
                nCommentLines++;
                continue;
            }
            else if ( bufCurLine.Find( _T( "//" )) != -1 )
            {
                nCommentLines++;
                nCodeLines++;
                continue;
            }
        }

        //////////////////////////////////////////////////////////////////////////
        if ( !bHasSettedCommentFlag
                && bufCurLine[0] == _T('{')
                && bufCurLine.Find( _T( '}' )) == -1 )
        {
            bHasSettedCommentFlag = TRUE;
            nCommentLines++;
            continue;
        }

        if (bHasSettedCommentFlag
                && bufCurLine[nLen - 1] != _T('}') )
        {
            nCommentLines++;
            continue;
        }
        else if ( bHasSettedCommentFlag
                  && bufCurLine[nLen - 1] == _T('}'))
        {
            bHasSettedCommentFlag = FALSE;
            nCommentLines++;
            continue;
        }

        //////////////////////////////////////////////////////////////////////////

        if ( bufCurLine.Find( _T( "//" ) ) == -1
                && bufCurLine.Find( _T( "{" ) ) == -1
                && bufCurLine.Find( _T( "}" ) ) == -1 )
        {
            if ( bHasSettedCommentFlag )
            {
                nCommentLines++;
                continue;
            }
            else
            {
                nCodeLines++;
                continue;
            }
        }

        //////////////////////////////////////////////////////////////////////////

        if ( bufCurLine.Find( _T( "//" ) ) == 0 && !bHasSettedCommentFlag && !bHasSettedQuatoFlag )
        {
            // single line comment
            nCommentLines++;
            continue;
        }

    }// End for
}
