#ifndef SrcTypeSelDlg_H
#define SrcTypeSelDlg_H

#include "SrcTypeSelDlgBase.h"
#include "CountingManager.h"

class SrcTypeSelDlg: public SrcTypeSelDlgBase
{
public:

    SrcTypeSelDlg(wxWindow *parent, wxWindowID id = wxID_ANY, const wxPoint &pos = wxDefaultPosition, const wxSize &size = wxDefaultSize);
    virtual ~SrcTypeSelDlg();

    void GetSrcTypes(wxString& strSrcTypes)
    {
        strSrcTypes = m_strSrcTypes;
    }
  
    void SetMapData(MapStrToCounterRule* pMapRule, MapStrToFileExtension* pMapFileExt)
    {
        m_pMapRule = pMapRule;
        m_pMapFileExtension = pMapFileExt;
    }

private:
    void OnBtnCancelClick(wxCommandEvent &event);
    void OnInit(wxInitDialogEvent &event);
    void OnBtnOkClick(wxCommandEvent &event);
    void Onm_ckbSelAllClick(wxCommandEvent &event);
    void OnBtnAddClick(wxCommandEvent &event);
    void OnLbxSrcTypesSelect(wxCommandEvent &event);
    void OnBtnEditClick(wxCommandEvent &event);
    void OnBtnDelClick(wxCommandEvent &event);

    wxString m_strSrcTypes;
    MapStrToCounterRule *m_pMapRule;
    MapStrToFileExtension *m_pMapFileExtension;

    FileExtension *getSelItemData();
    void updateSrcTypeLbx();
    void updateButtons();
};

#endif
